# Pkernel

PKI kernel - library for other system to create PKI aware application

This library is trying to abstract out the typical core API for the cryptographic operations and meant to be the basis of cryptographic API for the purpose regardless it is implemented in Java JCE (jruby), Java P#11 (jruby) or OpenSSL (ruby).

It is intended that user just require the required runtime implementation and maintain the high level (functional) API to enjoy the different implementations of library without needing the change of application API. 

This gem hold as high level API abstraction only, not implementation except some global data structure or sharable values between implementations.

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'pkernel'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install pkernel

## Usage

Check out the test/ folder in each implementation library for details usage.

## Development

After checking out the repo, run `bin/setup` to install dependencies. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/[USERNAME]/pkernel.

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).
